//+------------------------------------------------------------------+
//|                                                  Force Index.mq4 |
//|                                       Copyright  2008, omelette |
//|                                           omelette@oceanfree.net |
//|                                           Modified by PipeTrader |
//|                                    jean-marcdelorme@videotron.ca |
//+------------------------------------------------------------------+
#property copyright "Copyright  2008, omelette"
#property link      "omelette@oceanfree.net"

#property indicator_separate_window
#property indicator_buffers 1
#property indicator_color1 Lime
#property indicator_level1 0.03
#property indicator_level2 -0.06
#property indicator_levelcolor Crimson


//---- input parameters
extern bool Alerts_On = true;
extern bool Alerts_EOB = true; // End of bar alerts
extern double Alert_Trigger_Level_1 = 0.03;
extern double Alert_Trigger_Level_2 = 0.03;

extern int ExtForcePeriod=13;
extern int ExtForceMAMethod=0;
extern int ExtForceAppliedPrice=0;
extern bool FI_DisplayValue_On = true;
extern int FI_Value_X = 930;
extern int FI_Value_Y = 40;

//---- buffers
double ExtForceBuffer[],ATL[3];
bool EntryAllowed[3];
IndicatorShortName("FI");

//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
  

   string sShortName;
   SetIndexBuffer(0,ExtForceBuffer);
//---- indicator line
   SetIndexStyle(0,DRAW_HISTOGRAM);
//---- name for DataWindow and indicator subwindow label

  
   IndicatorShortName(sShortName);
   SetIndexLabel(0,sShortName);
//---- first values aren't drawn
   SetIndexDrawBegin(0,ExtForcePeriod);
   
   ATL[1] = Alert_Trigger_Level_1;
   ATL[2] = Alert_Trigger_Level_2;
   EntryAllowed[1] = true;
   EntryAllowed[2] = true;
  
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Force Index indicator                                            |
//+------------------------------------------------------------------+
int start()
  {
   int nLimit;
   int nCountedBars=IndicatorCounted();
//---- insufficient data
   if(Bars<=ExtForcePeriod) return(0);
//---- last counted bar will be recounted
   if(nCountedBars>ExtForcePeriod) nCountedBars--;
   nLimit=Bars-nCountedBars;
//---- Force Index counted
   for(int i=nLimit; i>=0; i--)
   {
     Print(i);
      ExtForceBuffer[i]=Volume[i]*
                        (iMA(NULL,0,ExtForcePeriod,0,ExtForceMAMethod,ExtForceAppliedPrice,i)-
                         iMA(NULL,0,ExtForcePeriod,0,ExtForceMAMethod,ExtForceAppliedPrice,i+1));
  
    if (FI_DisplayValue_On)
    {
     if (ExtForceBuffer[i] > 0)
      int NumColour = Blue;
     else NumColour = Red;
    
     ObjectDelete("PipeValue");  
     ObjectCreate("PipeValue", OBJ_LABEL, WindowFind("FI"), 0, 0);
     ObjectSet("PipeValue", OBJPROP_CORNER, 0);
     ObjectSet("PipeValue", OBJPROP_XDISTANCE, FI_Value_X);
     ObjectSet("PipeValue", OBJPROP_YDISTANCE, FI_Value_Y);  
     ObjectSetText("PipeValue",DoubleToStr(ExtForceBuffer[i],4),22, "Arial Bold", NumColour);
    }
  
  
  
   if (Alerts_On && i == Alerts_EOB) {
    for (int f=1; f<3; f++) {
     double TriggerLevel = ATL[f];
    if (MathAbs(ExtForceBuffer[i]) > TriggerLevel) {
     if (EntryAllowed[f]) {
      Alert("ForceIndex threshold ",f," exceeded... (M",Period()," ",Symbol(),")"); // alert by omelette
      Comment(MathAbs(ExtForceBuffer[1]));
      EntryAllowed[f] = false; } }
    else EntryAllowed[f] = true; } }
   }
//---- done
   return(0);
  }
//+------------------------------------------------------------------+